﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Photon.Pun;

public class PlayerMovement : MonoBehaviour
{
    public float speed = 18;

    private Rigidbody rig;
    public Transform body;

    private float hAxis;
    private float vAxis;

    private bool move;

    bool isMine;

    // Start is called before the first frame update
    void Start()
    {
        isMine = GetComponent<PhotonView>().IsMine;
        if(!isMine){
            move = false;
        }else{
            move = true;
        }
        rig = GetComponent<Rigidbody>();
    }

    // Update is called once per frame
    void Update()
    {
        if(move){
            hAxis = Input.GetAxis("Horizontal");
            vAxis = Input.GetAxis("Vertical");
        }
    }

    void FixedUpdate(){
        if(move){
            rig.isKinematic = true; 

            Vector3 movement = new Vector3(hAxis, 0.0f, vAxis) * speed * Time.deltaTime;
            
            if(movement != Vector3.zero){
                rig.transform.position += transform.forward * vAxis * Time.deltaTime * speed;
                rig.transform.position += transform.right * hAxis * Time.deltaTime * speed;
            }

            body.rotation = Quaternion.LookRotation(movement);

            rig.isKinematic = false;

        }
    }

    public void disablePlayerMovement(){
        move = false;
    }

    public void enablePlayerMovement(){
        move = true;
    }

    [PunRPC]
    public void GrabBarrel() {
        
    }

}